# Instructions:
# 1. Set sols_dir and sols_tar to an appropriate location where you have stored the sols.tar file.
#		It will be copied into the appropriate directory when the script is run
# 2. Copy this bash file into the main root directory for a student's btree implementation
# 3. Run: bash grade.sh
# 4. This script will test all cases and either print out Part # correct or that it is incorrect and a diff with the mistakes
#
# The students results will be placed in the results/ subdirectory with format
# test_#.mysol for there output and test_#.diff for the diff of their solution with the correct solution
#
# Please also verify that the student's code is actually implemented generally
# correctly (not doing some sort of ridiculous trick like grepping the data
# files)
#
# See the PDF for an explanation of the test cases
# Also please include on the Google Doc an explanation of how you are taking points off


# Set up the directory

rm -rf grading/
mkdir grading

echo "
] a
[ a
] middle
[ middle
] zxcvb
[ zxcvb
x
" > grading/test_empty

echo "
S a
] a
[ a
x
" > grading/test_1

echo "
S zzz
] zzz
[ zzz
x
" > grading/test_2

echo "
S tegl
] tegl
[ tegl
x
" > grading/test_3


echo "
S shoeshind
] shoeshind
[ shoeshind
x
" > grading/test_4

echo "
S daedam
] daedam
[ daedam
x
" > grading/test_5

function grade {
echo "*************** Grade Part $1 ***************"
./main < grading/test_$1 > results/test_$1.mysol
diff sols/test_$1.sol results/test_$1.mysol > results/test_$1.diff
if [ -s results/test_$1.diff ]
then
echo "Error in Part $1: see results/test_$1.mysol and results/test_$1.diff"
cat results/test_$1.diff
else
echo "Part $1 correct"
fi
echo ""
}

function runtest {
# Run
echo "Compile (wait a bit) [testing empty]"
echo "[5 points for success otherwise 0 points]"
make spotless  > /dev/null
make load_empty > /dev/null

rm -rf results/
mkdir results

grade empty

echo "Compile (wait a bit) [testing non-empty]"
echo "[2 points for each test, 1 for right bracket and 1 for left bracket]"
make spotless  > /dev/null
make load   > /dev/null


echo "Start grading"
for i in 1 2 3 4 5
do
	grade $i 
done

echo "Testing prefixes existing in B+ tree"
chmod +x functional_tests.py
./functional_tests.py

}

runtest

